/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Point;

class Gleisanzeige {
	Point p;
	Component parent;
	
	boolean einfahrt;
	boolean ausfahrt;
	boolean ein;
	
	public Gleisanzeige (Component par, int x, int y) {
		p = new Point (x, y);
		parent = par;
	}
	
	public void paint (Graphics g) {
		if (ein) g.setColor (Color.RED);
		else g.setColor (Color.WHITE);
//		g.drawOval (p.x - 7, p.y - 7, 12, 12);
//		g.fillOval (p.x - 7, p.y - 7, 12, 12);
		// Ach ja... manche Routinen muss man selber bauen...
		g.drawLine (p.x - 2, p.y - 6, p.x + 1, p.y - 6);
		g.drawLine (p.x - 4, p.y - 5, p.x + 3, p.y - 5);
		g.drawLine (p.x - 5, p.y - 4, p.x + 4, p.y - 4);
		g.drawLine (p.x - 5, p.y - 3, p.x + 4, p.y - 3);
		g.drawLine (p.x - 6, p.y - 2, p.x + 5, p.y - 2);
		g.drawLine (p.x - 6, p.y - 1, p.x + 5, p.y - 1);
		g.drawLine (p.x - 6, p.y    , p.x + 5, p.y    );
		g.drawLine (p.x - 6, p.y + 1, p.x + 5, p.y + 1);
		g.drawLine (p.x - 5, p.y + 2, p.x + 4, p.y + 2);
		g.drawLine (p.x - 5, p.y + 3, p.x + 4, p.y + 3);
		g.drawLine (p.x - 4, p.y + 4, p.x + 3, p.y + 4);
		g.drawLine (p.x - 2, p.y + 5, p.x + 1, p.y + 5);
	}
	
	public boolean einfahrtOk() {
		if (ein) return false;
//		if (ausfahrt) return false;
		return true;
	}
	
	public void einfahrtStellen () {
		einfahrt = true;
		ein = true;
		paint(parent.getGraphics());
	}
	
	public void einfahrtAufloesen () {
		einfahrt = false;
	}
	
	public void ausfahrtStellen () {
		ausfahrt = true;
		ein = true;
		paint(parent.getGraphics());
	}
	
	public boolean ausfahrtAufloesenOk () {
		if (einfahrt) return false;
		return true;
	}
	
	public void ausfahrtAufloesen () {
		ausfahrt = false;
		ein = false;
		paint(parent.getGraphics());
	}
}
