/*
 * HebelNeu.java
 *
 * Created on 4. Juni 2007, 14:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package guettingen;

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;
import javax.swing.JPopupMenu;

abstract class Hebel extends JComponent implements MouseListener {
	public Hebel(int nr, String ns) {
		// Hebelsperre: 80px Hebel: 420px
		setSize (60, 500);
		setBackground(Color.BLACK);
		addMouseListener (this);
		id = nr;
		
		nummernschild = Tools.loadImage (ns);		
	}
	
	public void mouseClicked (MouseEvent e) {
		// Die Grsse Betrgt 420 x 60
		int x;
		int y;
		
		x = e.getX();
		y = e.getY();
		
		if (hat_fb_hebel && !position) {
			if (x < 25 && y > 150 && y < 190) {
				fb_hebel_pos = !fb_hebel_pos;
				fahrbegriff_sound.play();
				repaint();
				return;
			}
		}
		if (y < 80) {
			if (e.getButton() == e.BUTTON1) {
				if (this instanceof Signalhebel) {
					((Signalhebel) this).taste = Signalhebel.SFR_T;
					pruefeHebelsperre();
				}
			} else {
				if (hsp_menu != null) {
					hsp_menu.show(this, e.getX(), e.getY());
				}
			}
		} else if (y > 80 && y < 500) {
			if (inPluslage()) positionMinus();
			else positionPlus();
		}
//		Stellwerk.hf.repaintHebel(id);
		repaint();
	}

	public void pruefeHebelsperre() {}
	public abstract void positionPlus ();
	public abstract void positionMinus ();
	public void drawLampe(Graphics g) { }
	
	public boolean inPluslage () {
		return (!position);
	}
	
	public boolean inMinuslage () {
		return (position);
	}
	
	public void paint (Graphics g) {
		// g.clearRect (0, 0, 60, 500);
		g.setColor(Color.BLACK);
		g.fillRect(0, 0, 60, 500);
		if (hebelsperre != null) {
			g.drawImage (hebelsperre, 0, 0, null);
			drawLampe(g);
		}
		
		if (position) {
			g.drawImage (hebel_minus, 0, 80, null);
			g.drawImage (nummernschild, 25, 390, null);
			if (hat_fb_hebel) {
				if (fb_hebel_pos) g.drawImage(fbh_unten, 15, 390, null);
				else g.drawImage(fbh_oben, 15, 390, null);
			}
		} else {
			g.drawImage (hebel_plus, 0, 80, null);
			g.drawImage (nummernschild, 25, 150, null);
			if (hat_fb_hebel) {
				if (fb_hebel_pos) g.drawImage(fbh_unten, 15, 150, null);
				else g.drawImage(fbh_oben, 15, 150, null);
			}
		}
	}
	
	protected void hebelsperreEinschalten() {
		if (hebelsperre_frei) return;
		hebelsperre_frei = true;
		freigabe_sound.play();
		repaint();
	}
	
	protected void hebelsperreAusschalten() {
		if (!hebelsperre_frei) return;
		hebelsperre_frei = false;
		freigabe_sound.play();
		repaint();
	}
	
	public void mousePressed (MouseEvent e) { }
	public void mouseReleased (MouseEvent e) { }
	public void mouseEntered (MouseEvent e) { }
	public void mouseExited (MouseEvent e) { }

	protected BufferedImage hebel_plus;
	protected BufferedImage hebel_minus;
	protected BufferedImage nummernschild;
	protected BufferedImage hebelsperre;
	
	protected boolean position;
	protected boolean hat_fb_hebel;
	protected boolean fb_hebel_pos;
	protected boolean hebelsperre_frei;
	
	static BufferedImage wh_plus;
	static BufferedImage wh_minus;
	static BufferedImage sh_plus;
	static BufferedImage sh_minus;
	static BufferedImage fbh_oben;
	static BufferedImage fbh_unten;
	
	static BufferedImage esig_hsp;
	static BufferedImage asig_hsp;
	static BufferedImage weichen_hsp;
	
	static AudioClip weichenhebel_sound;
	static AudioClip signalhebel_sound;
	static AudioClip fahrbegriff_sound;
	static AudioClip freigabe_sound;
	
	BufferedImage bild;
	
	protected JPopupMenu hsp_menu;
	
	static {
		esig_hsp = Tools.loadImage ("signalkasten_ein");
		asig_hsp = Tools.loadImage ("signalkasten_aus");
		weichen_hsp = Tools.loadImage ("weichenkasten");

		sh_plus = Tools.loadImage("signalhebel_plus");
		sh_minus = Tools.loadImage("signalhebel_minus");
		wh_plus = Tools.loadImage("weichenhebel_plus");
		wh_minus = Tools.loadImage("weichenhebel_minus");
		fbh_oben = Tools.loadImage("fb_hebel_oben");
		fbh_unten = Tools.loadImage("fb_hebel_unten");
		
		signalhebel_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/SH.wav"));
		weichenhebel_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/WH.wav"));
		fahrbegriff_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/FB.wav"));
		freigabe_sound = Applet.newAudioClip(ClassLoader.getSystemResource("sounds/SF.wav"));
	}
	
	int id;
}
